function f(x,coeff)
   -- fonction qui a x renvoie f(x) 
   local taille=matrix.size(coeff)
   local puiss=matrix(taille,1)
   for i=1,taille do
      puiss[i][1]=(x)^(i-1)
   end
   return matrix.transpose(coeff)*puiss
end

function trace(points,coeff,largeurPage)
   -- code de tracé avec tikz, points table de (x,y), coeff matrix de
   -- coeff et largeurPage sortie de \the\linewidth 
   -----------------------------------------------

   -- on trie les points selon x utilisation de la 
   -- fonction sort (higher-order function)
   table.sort(points, function (a,b) return (a.x<b.x) end)
   -- min max et pas (50 points sur la courbe)
   local minX=points[1].x
   local maxX=points[#points].x
   local pas=math.abs(maxX-minX)/50
   -- idem selon y, l'odre dans lequel
   -- est le tableau n'importe pas
   table.sort(points, function (a,b) return (a.y<b.y) end)
   local minY=points[1].y
   local maxY=points[#points].y

   --pt to centimètre
   local conv=0.035145979
   local larg=string.gsub(largeurPage,"pt","")
   local largeurPageCm=0.8*larg*conv
   
   -- unité
   local Xunit=largeurPageCm/math.abs(maxX-minX)
   local Yunit=(0.6*largeurPageCm)/math.abs(maxY-minY)


   -- on écrit du code tikz
   -- on ouvre la figure en réglant les unités
   tex.sprint("\\noindent\\begin{tikzpicture}[x="..Xunit.."cm,y="..Yunit.."cm]")
   -- les axes
   tex.sprint("\\draw[->,line width=0.7pt] ("..points[1].x ..","..(minY-0.5)..")--("..(points[#points].x+0.4) ..","..(minY-0.5)..")")
   for i=1,9 do
      tex.sprint("node[pos="..(0.1*i).."]{\\begin{tikzpicture}\\draw[-](0,0)--(0,0.1);\\end{tikzpicture}}") 
      tex.sprint("node[pos="..(0.1*i)..",anchor=north]{"..(string.format(" %.3f",(0.1*i*(points[#points].x+0.4-points[1].x)))).."}")
   end
   tex.sprint("node[pos=0.95,anchor=north] {$x$}")
   tex.sprint(";")
   tex.sprint("\\draw[->,line width=0.7pt] ("..(minX)..","..(minY-0.5)..")--("..(minX)..","..(maxY)..")")
   for i=1,9 do
      tex.sprint("node[pos="..(0.1*i).."]{\\begin{tikzpicture}\\draw[-](0,0)--(0.1,0);\\end{tikzpicture}}")  
      tex.sprint("node[pos="..(0.1*i)..",anchor=east]{"..(string.format(" %.3f",(0.1*i*(maxY-minY+0.5)))).."}")
   end
   tex.sprint("node[pos=0.95,anchor=east] {$y$}")
   tex.sprint(";")
  
   -- on met les points
   for i=1,#points do
      tex.sprint("\\fill[color=point]("..points[i].x ..","..points[i].y ..") circle (2pt) ;")
   end
   -- on trace la regression
   tex.sprint("\\draw[color=regression,line width=1pt]")
   for i=1,51 do
      local x=minX+(i-1)*pas
      local y=tostring(f(x,coeff))
      if i~=51 then
         tex.sprint("("..x..","..y..")--")
      else
         tex.sprint("("..x..","..y..");")
      end
   end
   tex.sprint("\\node[draw,fill=white,text width="..(1.4*math.abs(maxX-minX)).."cm] at("..(0.8*maxX)..","..(0.5*maxX)..") {régression : $");
   for i=1,matrix.size(coeff) do
      if i==1 then
         tex.sprint(string.format(" %.4f", coeff[i][1]))
      elseif i==2 then
         tex.sprint(string.format(" %.4f", coeff[i][1]).."x")
      else 
         tex.sprint(string.format(" %.4f", coeff[i][1]).."x^{"..(i-1).."}")
      end

      if i~= matrix.size(coeff) then
         if coeff[i+1][1]>=0 then
            tex.sprint("+")
         end
      end
   end
   tex.sprint("$};\\end{tikzpicture}")
end
